//
//  LtNavigationController.m
//  CustomNavigation
//
//  Created by Radu Lucaciu on 4/12/13.
//  Copyright (c) 2013 Radu. All rights reserved.
//

#import "RLTransNavigationController.h"


#define kTransitionDuration 0.7

@interface RLTransNavigationController ()
{
    UIView *overlayView;
}

@end

@implementation RLTransNavigationController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self)
    {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)pushViewController:(UIViewController *)viewController animated:(BOOL)animated
{
    if (animated)
    {
        [self createOverlayView];
        
        overlayView.alpha = 0;
        CGRect originalFrame = self.view.frame;
        RLTransNavigationController *nc = [[RLTransNavigationController alloc] initWithRootViewController:viewController];
        [self.view.window addSubview:nc.view];
        nc.view.frame = CGRectMake(originalFrame.size.width, 0, originalFrame.size.width, originalFrame.size.height);
        
        [UIView animateWithDuration:kTransitionDuration animations:^{
            overlayView.alpha = 0.7;
            [self.view addSubview:overlayView];
            self.view.transform = CGAffineTransformMakeScale(0.7, 0.7);
            
            //This is an ugly workaround to prevent a bug that caused the topViewController's view to move up when applying
            //a transform to the Navigation Controller
            self.topViewController.view.hidden = YES;
            self.topViewController.view.hidden = NO;
            
            nc.view.frame = CGRectMake(0, 0, originalFrame.size.width, originalFrame.size.height);
        } completion:^(BOOL finished){
            [overlayView removeFromSuperview];
            self.view.transform = CGAffineTransformMakeScale(1, 1);
            [super pushViewController:viewController animated:NO];
            [nc.view removeFromSuperview];
            
            [self setNavigationBarHidden:YES];
            [self setNavigationBarHidden:NO];
        }];
    }
    else
    {
        [super pushViewController:viewController animated:animated];
    }
}

- (UIView *)createOverlayView
{
    if (!overlayView)
    {
        overlayView = [[UIView alloc] initWithFrame:self.view.bounds];
        overlayView.backgroundColor = [UIColor blackColor];
    }
    
    return overlayView;
}

- (UIViewController *)popViewControllerAnimated:(BOOL)animated
{
    if (animated)
    {
        CGRect originalFrame = self.view.frame;
        self.view.alpha = 0.2;
        self.view.transform = CGAffineTransformMakeScale(0.7, 0.7);
        
        UIViewController *poppedVc = [super popViewControllerAnimated:NO];
        RLTransNavigationController *nc = [[RLTransNavigationController alloc] initWithRootViewController:poppedVc];
        nc.view.frame = CGRectMake(0, 0, originalFrame.size.width, originalFrame.size.height);
        [self.view.window addSubview:nc.view];
        
        [UIView animateWithDuration:kTransitionDuration animations:^{
            self.view.alpha = 1.0;
            self.view.transform = CGAffineTransformMakeScale(1, 1);
            nc.view.frame = CGRectMake(originalFrame.size.width, 0, originalFrame.size.width, originalFrame.size.height);
        } completion:^(BOOL finished){

        }];
        return poppedVc;
    }
    else
    {
        return [super popViewControllerAnimated:animated];
    }
}

@end
